/*--------------------------------------------------------------------------------------------------*/
/* 				Function for the computation of the dimensions of the communication grid			*/
/*       				(if flag==1, we use a cubic partitioning of the grid,						*/
/*                        otherwise, we set grid diensions manually) 								*/
/*                                                                           						*/
/* A. P. Liavas																						*/
/* Georgios Lourakis																				*/ 
/* Georgios Kostoulas																				*/ 
/* 15/11/2017                                              											*/
/*--------------------------------------------------------------------------------------------------*/
#include "ntf_functions.h"

void Compute_Grid_Dimensions(int *p_A, int *p_B, int *p_C, int comm_sz, int flag){
	int q = cbrt(comm_sz);;				// comm_sz = q*q*q

	//	<----------------------	Cubic Partitioning (Default choice)		------------------->	//
	if (flag==1){					
		*p_A = q;
		*p_B = q;
		*p_C = q;
	}
	//	<----------------------------	Manual Partitioning		---------------------------->	//
	else{
		if (comm_sz==64){
			*p_A = 1;
			*p_B = 1;
			*p_C = 64;
		}		
		else if (comm_sz==9){
			*p_A = 3;
			*p_B = 1;
			*p_C = 3;
		}		
		else if (comm_sz==36){
			*p_A = 6;
			*p_B = 1;
			*p_C = 6;
		}		
		else if (comm_sz==121){
			*p_A = 11;
			*p_B = 1;
			*p_C = 11;
		}		
		else if (comm_sz==225){
			*p_A = 15;
			*p_B = 1;
			*p_C = 15;
		}		
		else if (comm_sz==361){
			*p_A = 19;
			*p_B = 1;
			*p_C = 19;
		}			
		else if (comm_sz==529){
			*p_A = 23;
			*p_B = 1;
			*p_C = 23;
		}		
		else if (comm_sz==512){
			*p_A = 2;
			*p_B = 2;
			*p_C = 128;
		}		
		else if (comm_sz==400){
			*p_A = 1;
			*p_B = 1;
			*p_C = 400;
		}
		else if (comm_sz==343){
			*p_A = 1;
			*p_B = 1;
			*p_C = 343;
		}
		else if (comm_sz==344){
			*p_A = 2;
			*p_B = 2;
			*p_C = 86;
		}
		else if (comm_sz==216){
			*p_A = 1;
			*p_B = 1;
			*p_C = 216;
		}
		else if (comm_sz==125){
			*p_A = 1;
			*p_B = 1;
			*p_C = 125;
		}
		else if (comm_sz==124){
			*p_A = 2;
			*p_B = 2;
			*p_C = 31;
		}
		else if (comm_sz==27){
			*p_A = 1;
			*p_B = 1;
			*p_C = 27;
		}
		else if (comm_sz==8){
			*p_A = 1;
			*p_B = 1;
			*p_C = 8;
		}
		else{
			*p_A = 1;
			*p_B = 1;
			*p_C = 1;
		}
	}
}
